<template>
  <b-container>
    <table class="table table-striped">
      <thead>
        <tr>
          <th scope="col">Date</th>
          <th scope="col">WeekDay</th>
          <th scope="col">IN</th>
          <th scope="col">OUT</th>
          <th scope="col">LUNCH</th>
          <th scope="col">Status</th>
          <th scope="col">+/-</th>
          <th scope="col">Plan</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="(day,index) in days" :key="index">
          <td scope="row">{{day.date}}</td>
          <td colspan="1">
            {{day.weekDay}}
          </td>
          <td>
            <b-form-timepicker :disabled="day.status == workPlansEnum.holiday || day.status == workPlansEnum.publicHoliday"  v-model="day.in" locale="en" hourCycle="h23"></b-form-timepicker>
          </td>
          <td> <b-form-timepicker :disabled="day.status == workPlansEnum.holiday || day.status == workPlansEnum.publicHoliday" v-model="day.out" locale="en"></b-form-timepicker></td>
          <td class="lunch">
            <vue-timepicker  :disabled="day.status == workPlansEnum.holiday || day.status == workPlansEnum.publicHoliday" v-model="day.lunch"  placeholder="hh:mm"></vue-timepicker>
          </td>
          <td>
            <select class="form-control" v-model="day.status">
              <option :value="null">Select Status</option>
              <option v-for="(plan, index) in optionsOfWorkPlans" :key="index">{{plan}}</option>
            </select>
          </td>
          <td>
            <span v-if="day.lunch">
              {{getLunch(day)}}
         
            </span>
           
          </td>
          <td>
            {{getPlan(day)}}
          </td>
        </tr>
        <tr>
          <td colspan="5" class="text-left">Totals</td>
          <td>{{getTotal}}</td>
          <td>{{getTotalLunch}}</td>
          <td>{{getTotalPlan}}</td>
        </tr>

      </tbody>
    </table>
    <b-button @click="addNewDay">Add New Day</b-button>
  </b-container>
</template>
<script>
import VueTimepicker from 'vue2-timepicker'
import 'vue2-timepicker/dist/VueTimepicker.css'
import {workPlansEnum} from '@/shared/workPlans'
export default {
  components: { VueTimepicker },
  data() {
    return {
      
      days: [],
      optionsOfWorkPlansEnum:{

      },
      optionsOfWorkPlans:[
        'Work',
        'Work from home',
        'Business trip',
        'Holiday',
        'Public holiday'
      ]
    };
  },
  computed:{
    workPlansEnum() {
      return workPlansEnum;
    },
    getTotalPlan() {
      let totalHours = 0;
      let totalMinutes = 0;
      for(let day of this.days) {
        let [hh, mm] = this.getPlan(day).split(':');
        totalHours += Number(hh)
        totalMinutes += Number(mm)
      }
      return `${totalHours}:${('0' + totalMinutes).slice(-2)}`;
    },
    getTotalLunch() {
      let totalHours = 0;
      let totalMinutes = 0;
      for(let day of this.days) {
        let [hh, mm] = this.getLunch(day).split(':');
        totalHours += Number(hh)
        totalMinutes += Number(mm)
      }
      return `${totalHours}:${('0' + totalMinutes).slice(-2)}`;
    },
    getTotal() {
      let totalHours = 0;
      let totalMinutes = 0;
      let [hhOfPlan,mmOfPlan] = this.getTotalPlan.split(':');
      let[hhOfLunch, mmOfLunch] = this.getTotalLunch.split(':')
      totalHours += Number(hhOfPlan);
      totalHours += Number(hhOfLunch);
      totalMinutes+= Number(mmOfPlan);
      totalMinutes +=Number(mmOfLunch);
      return `${totalHours}:${('0' + totalMinutes).slice(-2)}`;
    }
  },
  methods:{

    getPlan(day) {
      let [h, m] = day.in.split(':');
      let [hh, mm] = day.out.split(':');

      let checkInDate = new Date()
      checkInDate.setHours(h);
      checkInDate.setMinutes(m); 


      let checkOutDate = new Date() 
      checkOutDate.setHours(hh);
      checkOutDate.setMinutes(mm); 


      let distance = Math.abs(checkInDate - checkOutDate);
      const hours = Math.floor(distance / 3600000);
      distance -= hours * 3600000;
      const minutes = Math.floor(distance / 60000);
      distance -= minutes * 60000;
      if(day.status == workPlansEnum.holiday || day.status == workPlansEnum.publicHoliday) {
        return '0:00'
      } else {
        return `${hours}:${('0' + minutes).slice(-2)}`;
      }
       
    },
    addNewDay() {
     const weekday = ["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"];
      let today = new Date()
      today.setDate(today.getDate() + this.days.length)
      let date = `${today.getDate()}-${today.getMonth() + 1}`
      let dayName = weekday[today.getDay()]
      this.days.push({
          date:date,
          weekDay:dayName,
          in:'08:00',
          out:'16:00',
          lunch:{
            HH:'00',
            mm:'00'
          },
          status:null,
      })
    },
    getLunch(day) {
      if(day.status == workPlansEnum.holiday || day.status == workPlansEnum.publicHoliday) {
        return '0:00'
      } else {
        return  `${day.lunch.HH}:${day.lunch.mm}`
      }

    }

  }
};
</script>
<style scoped>
.lunch {
  width:8rem
}
</style>